class KFBloodExplo extends BloodExplosion;

#exec OBJ LOAD FILE=KFX.utx

var class<xScorch> SplatterClass;

state Ticking
{
	simulated function Tick( float dt )
	{
		if( LifeSpan < 1.0 )
		{
			mRegenRange[0] *= LifeSpan;
			mRegenRange[1] = mRegenRange[0];
		}
	}
}

simulated function timer()
{
	GotoState('Ticking');
}

simulated function PostNetBeginPlay()
{
	SetTimer(LifeSpan - 1.0,false);
	if ( Level.NetMode != NM_DedicatedServer )
		WallSplat();
	Super.PostNetBeginPlay();
}

simulated function WallSplat()
{
	local vector WallHit, WallNormal;
	local Actor WallActor;

	if ( FRand() > 0.8 )
		return;
	WallActor = Trace(WallHit, WallNormal, Location + vect(0,0,-200), Location, false);
	if ( WallActor != None )
		spawn(SplatterClass,,,WallHit + 20 * (WallNormal + VRand()), rotator(-WallNormal));
}

defaultproperties
{
     SplatterClass=Class'XEffects.BloodSplatter'
     mStartParticles=10
     mMaxParticles=20
     mDelayRange(1)=0.000000
     mRegenRange(0)=6.000000
     mRegenRange(1)=6.000000
     mDirDev=(X=2.700000,Y=2.500000)
     mPosDev=(X=2.000000,Y=2.000000,Z=5.000000)
     mSpeedRange(0)=40.000000
     mSpeedRange(1)=60.000000
     mSizeRange(0)=40.000000
     mSizeRange(1)=0.000000
     Skins(0)=Texture'KFX.BloodSplash'
     mNumTileColumns=2
     mNumTileRows=2
     bUnlit=false
}
