class KFFire extends InstantFire
    abstract;

var float LastClickTime;
var float LastFireTime;

var() Name EmptyAnim;
var() float EmptyAnimRate;
var() Name EmptyFireAnim;
var() float EmptyFireAnimRate;
var bool Empty;


simulated function bool AllowFire()
{
    if(KFWeapon(Weapon).bIsReloading)
        return false;

    if(KFWeapon(Weapon).ClipCount < 1)
    {
        if(Level.TimeSeconds - LastClickTime > FireRate)
        {
            Weapon.PlayOwnedSound(NoAmmoSound, SLOT_Interact, TransientSoundVolume,,,, false);
            LastClickTime = Level.TimeSeconds;

            if(Weapon.HasAnim(EmptyAnim))
                weapon.PlayAnim(EmptyAnim, EmptyAnimRate, 0.0);
        }

        return false;
        Empty=true ;
    }

    LastClickTime = Level.TimeSeconds;

    return Super.AllowFire();

}


function InitEffects()
{
    Super.InitEffects();
    if ( FlashEmitter != None )
        Weapon.AttachToBone(FlashEmitter, KFWeapon(Weapon).FlashBoneName);
}

function FlashMuzzleFlash()
{
    local rotator r;
    r.Roll = Rand(65536);
    Weapon.SetBoneRotation('Bone_Flash', r, 0, 1.f);
    Super.FlashMuzzleFlash();
}

event ModeDoFire()
{
    if ( Level.TimeSeconds - LastFireTime > 0.5 )
        Spread = Default.Spread;
    else
        Spread = FMin(Spread+0.02,0.12);

    LastFireTime = Level.TimeSeconds;
    Super.ModeDoFire();
}

/*
function PlayFiring()
{

   if ( Weapon.Mesh != None )

    {  Weapon.PlayOwnedSound(FireSound,SLOT_Interact,TransientSoundVolume,,TransientSoundRadius,Default.FireAnimRate/FireAnimRate,false);
         ClientPlayForceFeedback(FireForce);  // jdf

         FireCount++;


        if(FireCount > 0 )
        {
          if(Empty==false)
          Weapon.PlayAnim(FireAnim, FireAnimRate, 0.0);

          if(Empty==true)
          Weapon.PlayAnim(EmptyFireAnim, EmptyFireAnimRate, 0.0);
        }

    }






}
*/

defaultproperties
{
     EmptyAnim=Empty
     EmptyFireAnim=EmptyFire
     EmptyAnimRate=1.0
     EmptyFireAnimRate=1.0
     SmokeEmitterClass=none

}
