Class KFMainMenu extends UT2k4MainMenu;


#exec OBJ LOAD FIlE=2K4Menus.utx


function bool MyOnDraw(Canvas Canvas)
{
    local GUIButton FButton;
    local int i,x2;
    local float XL,YL;
    local float DeltaTime;

    if (bAnimating || !Controller.bCurMenuInitialized )
        return false;

    DeltaTime=Controller.RenderDelta;

    for (i=0;i<Controls.Length;i++)
    {
        if ( (GUIButton(Controls[i])!=None) )
        {

            FButton = GUIButton(Controls[i]);
            if (FButton.Tag>0 && FButton.MenuState!=MSAT_Focused)
            {
                FButton.Tag -= 784*DeltaTime;
                if (FButton.Tag<0)
                    FButton.Tag=0;
            }
            else if (FButton.MenuState==MSAT_Focused)
                FButton.Tag=200;

            if (FButton.Tag>0)
            {
                fButton.Style.TextSize(Canvas,MSAT_Focused, FButton.Caption,XL,YL,FButton.FontScale);
                x2 = FButton.ActualLeft() + XL + 16;
                Canvas.Style=5;
                Canvas.SetDrawColor(150,25,25,FButton.Tag);
                Canvas.SetPos(0,fButton.ActualTop());
                Canvas.DrawTilePartialStretched(material'Highlight',x2,FButton.ActualHeight());
            }
        }
    }

    return false;
}




function MoveOn()
{
    switch (Selected)
    {
        case b_SinglePlayer:
            Profile("SinglePlayer");
            Controller.OpenMenu(Controller.GetSinglePlayerPage());
            Profile("SinglePlayer");
            return;

        case b_MultiPlayer:
            if ( !Controller.AuthroizeFirewall() )
            {
                Controller.OpenMenu("GUI2K4.UT2K4GenericMessageBox",FireWallTitle,FireWallMsg);
                return;
            }
            Profile("ServerBrowser");
            Controller.OpenMenu(Controller.GetServerBrowserPage());
            Profile("ServerBrowser");
            return;

        case b_Host:
            if ( !Controller.AuthroizeFirewall() )
            {
                Controller.OpenMenu("GUI2K4.UT2K4GenericMessageBox",FireWallTitle,FireWallMsg);
                return;
            }
            Profile("MPHost");
            Controller.OpenMenu(Controller.GetMultiplayerPage());
            Profile("MPHost");
            return;

        case b_InstantAction:
            Profile("InstantAction");
            Controller.OpenMenu(Controller.GetInstantActionPage());
            Profile("InstantAction");
            return;

        case b_ModsAndDemo:
            if ( !Controller.AuthroizeFirewall() )
            {
                Controller.OpenMenu("GUI2K4.UT2K4GenericMessageBox",FireWallTitle,FireWallMsg);
                return;
            }
            Profile("ModsandDemos");
            Controller.OpenMenu(Controller.GetModPage());
            Profile("ModsandDemos");
            return;

        case b_Settings:
            Profile("Settings");
            Controller.OpenMenu(Controller.GetSettingsPage());
            Profile("Settings");
            return;

        case b_Quit:
            Profile("Quit");
            Controller.OpenMenu(Controller.GetQuitPage());
            Profile("Quit");
            return;

        default:
            StopWatch(True);
    }
}




function MenuIn_OnArrival(GUIComponent Sender, EAnimationType Type)
{
    Sender.OnArrival = none;
    if ( bAnimating )
        return;

    i_UT2Shader.OnDraw = MyOnDraw;
    DesiredCharFade=255;
    CharFadeTime = 0.75;

    if (!Controller.bQuietMenu)
        PlayerOwner().PlaySound(FadeInSound);

  //  b_SinglePlayer.Animate(0.315359,0.368813,0.35);
  //  b_SinglePlayer.OnArrival = PlayPopSound;
  //  b_Multiplayer.Animate(0.363246,0.449282,0.40);
 //   b_Multiplayer.OnArrival = PlayPopSound;
  //  b_Host.Animate(0.395097,0.534027,0.45);
  //  b_Host.OnArrival = PlayPopSound;
    b_InstantAction.Animate(0.315359,0.368813,0.35);
    b_InstantAction.OnArrival = PlayPopSound;
  //  b_ModsAndDemo.Animate(0.433406,0.705859,0.55);
  //  b_ModsAndDemo.OnArrival = PlayPopSound;
    b_Settings.Animate(0.363246,0.449282,0.40);
    b_Settings.OnArrival = PlayPopSound;
    b_Quit.Animate(0.395097,0.534027,0.45);
    b_Quit.OnArrival = MenuIn_Done;
}

defaultproperties
{


    bDebugging=True
    OnOpen=InternalOnOpen
    OnCanClose=CanClose
    OnKeyEvent=MyKeyEvent
    OnReopen=MainReopened

    Begin Object Class=BackgroundImage Name=PageBackground
        Image=material'2K4Menus.Controls.mmbgnd'
        ImageStyle=ISTY_Scaled
        ImageRenderStyle=MSTY_Alpha
        X1=0
        Y1=0
        X2=1024
        Y2=768
    End Object

    Begin Object Class=GUIImage Name=iPanHuge

    End Object

    Begin Object Class=GUIImage Name=iPanBig

    End Object

    Begin Object Class=GUIImage Name=iPanSmall


    End Object

    Begin Object Class=BackgroundImage Name=ImgBkChar
        ImageRenderStyle=MSTY_Alpha
        ImageColor=(R=255,G=255,B=255,A=160)
        OnDraw=BkCharDraw
        RenderWeight=0.04
        X1=0
        Y1=0
        X2=1024
        Y2=768
        Tag=0
    End Object

    Begin Object Class=GUIImage Name=ImgUT2Logo

    End Object

    Begin Object Class=GUIImage Name=ImgUT2Shader

    End Object

    Begin Object Class=GUIImage Name=ImgTV

    End Object


       Begin Object Class=GUIButton Name=SinglePlayerButton
    End Object


    Begin Object Class=LadderButton Name=InstantActionButton
        Graphic = Material'2K4Menus.Mainmenu.SPButton'
        FontScale=FNS_Small
        StyleName="TextButton"
        Caption=" "
        CaptionEffectStylename="TextButtonEffect"
        CaptionAlign=TXTA_Left
        Hint="Sharpen your teeth on some AI"
        OnClick=ButtonClick
        WinWidth=0.593666
        WinHeight=0.075000
        WinLeft=0.423640
        WinTop=0.618619
        bFocusOnWatch=true
        TabOrder=1
        bUseCaptionHeight=true
    End Object


    Begin Object Class=LadderButton Name=MultiplayerButton
        Graphic = Material'2K4Menus.Mainmenu.MPButton'
        FontScale=FNS_Small
        StyleName="TextButton"
        Caption=" "
        CaptionEffectStylename="TextButtonEffect"
        CaptionAlign=TXTA_Left
        Hint="All hell breaks loose..."
        OnClick=ButtonClick
        WinWidth=0.659899
        WinHeight=0.075000
        WinLeft=0.363246
        WinTop=0.449282
        bFocusOnWatch=true
        TabOrder=2
        bUseCaptionHeight=true
    End Object


    Begin Object Class=LadderButton Name=HostButton
        Graphic = Material'2K4Menus.Mainmenu.CGButton'
        FontScale=FNS_Small
        StyleName="TextButton"
        Caption=" "
        CaptionEffectStylename="TextButtonEffect"
        CaptionAlign=TXTA_Left
        Hint="Start a server and invite others to join your game"
        OnClick=ButtonClick
        WinWidth=0.627131
        WinHeight=0.075000
        WinLeft=0.395097
        WinTop=0.534027
        bFocusOnWatch=true
        TabOrder=3
        bUseCaptionHeight=true
    End Object

    Begin Object Class=LadderButton Name=SettingsButton
        Graphic = Material'2K4Menus.Mainmenu.STButton'
        FontScale=FNS_Small
        StyleName="TextButton"
        Caption=" "
        CaptionEffectStylename="TextButtonEffect"
        CaptionAlign=TXTA_Left
        Hint="Change your controls and settings"
        OnClick=ButtonClick
        WinWidth=0.580478
        WinHeight=0.075000
        WinLeft=0.434477
        WinTop=0.800327
        bFocusOnWatch=true
        TabOrder=4
        bUseCaptionHeight=true
    End Object

    Begin Object Class=LadderButton Name=QuitButton

        Graphic = Material'2K4Menus.Mainmenu.EGButton'
        FontScale=FNS_Small
        StyleName="TextButton"
        Caption=" "
        CaptionEffectStylename="TextButtonEffect"
        CaptionAlign=TXTA_Left
        Hint="Leave the game"
        OnClick=ButtonClick
        WinWidth=0.526767
        WinHeight=0.075000
        WinLeft=0.424711
        WinTop=0.887567
        bFocusOnWatch=true
        TabOrder=5
        bUseCaptionHeight=true
    End Object

    i_Background=PageBackground
    i_PanHuge=iPanHuge
    i_PanBig=iPanBig
    i_PanSmall=iPanSmall
    i_UT2Logo=ImgUT2Logo
    i_UT2Shader=ImgUT2Shader
    i_BkChar=ImgBkChar
    i_TV=ImgTV
    b_InstantAction=InstantActionButton
    b_MultiPlayer=MultiplayerButton
    b_Host=HostButton
    b_Settings=SettingsButton
    b_Quit=QuitButton

    WinWidth=1.0
    WinHeight=1.0
    WinTop=0.0
    WinLeft=0.0

    bRenderWorld=False
    bAllowClose=False
    bAllowedAsLast=true
    bDisconnectOnOpen=true
    CharFade=0
    CharShots(0)=material'2K4Menus.MainMenu.Char01'
    CharShots(1)=material'2K4Menus.MainMenu.Char02'
    CharShots(2)=material'2K4Menus.MainMenu.Char03'
    NewNewsMsg="  (New Update Available)"
    MenuSong="KFMenu"

    PopInSound=sound'2K4MenuSounds.MainMenu.OptionIn'
    SlideInSound=sound'2K4MenuSounds.MainMenu.GraphSlide'
    FadeInSound=sound'2K4MenuSounds.MainMenu.CharFade'
    BeepSound=Sound'MenuSounds.select3'

    FireWallTitle="Important"
    FireWallMsg="It has been determined that the Window's Firewall is enabled and that UT2004 is not yet authorized to connect to the internet.  Authorization is required in order to use the online components of the game.  Please refer to the README.TXT for more information."
}
