//=============================================================================
// L85 Inventory class
//=============================================================================
class L85 extends KFWeapon
config(user);



#exec OBJ LOAD FILE=KillingFloorWeapons.utx
#exec OBJ LOAD FILE=KillingFloorHUD.utx

var transient float LastFOV;
var() bool zoomed;
var color ChargeColor;

var float Range;
var float LastRangingTime;

var() Material ZoomMat;
var() Sound ZoomSound;

simulated function DoToggle ()
{
  local xPawn P;
  local Controller C;
  local PlayerController Player;

  Player = PlayerController(C);
  P = xPawn(Owner);
  if ( (P != None) )
  {
    FireMode[0].bWaitForRelease =  !FireMode[0].bWaitForRelease;
    if ( FireMode[0].bWaitForRelease == True )
    {
     Player.ReceiveLocalizedMessage(class'KFmod.L85SwitchMessage');
    } else {
      Player.ReceiveLocalizedMessage(class'KFmod.L85SwitchMessage');
    }
    Super.DoToggle();
  }
}

function bool RecommendRangedAttack()
{
	return true;
}

function bool RecommendLongRangedAttack()
{
    return true;
}

function float SuggestAttackStyle()
{
    return -1.0;
}

exec function SwitchModes()
{
  DoToggle();
}




simulated event RenderOverlays(Canvas Canvas)
{
        local PlayerController PC;

	PC = PlayerController(Instigator.Controller);



	if(PC == None)
		return;


/*	  if ( !PC.bFrozen )
        {
            SetZoomBlendColor(Canvas);
            Canvas.Style = ERenderStyle.STY_Normal;
            Canvas.Style = 255;
            Canvas.SetPos((Canvas.SizeX - Canvas.SizeY) / 2,0);
            Canvas.DrawTile( Texture'KillingfloorHUD.ClassMenu.L85', Canvas.SizeY, Canvas.SizeY, -700, -750, 512, 512);

            Super.RenderOverlays (Canvas);
        }*/


	if(LastFOV != PC.DesiredFOV)
		PlaySound(ZoomSound, SLOT_Misc, 0.1,,,, false);

	LastFOV = PC.DesiredFOV;

	if (PC.DesiredFOV == PC.DefaultFOV || (Level.bClassicView && PC.DesiredFOV == 90))
	{
		Super.RenderOverlays(Canvas);
		zoomed=false;
	}
	else
	{
		SetZoomBlendColor(Canvas);

		//Black-out either side of the main zoom circle.
		Canvas.Style = ERenderStyle.STY_Normal;
		Canvas.SetPos(0, 0);
		Canvas.DrawTile(Texture'KillingFloorWeapons.L85.L85Cross', (Canvas.SizeX - Canvas.SizeY) / 2, Canvas.SizeY, 0.0, 0.0, 8, 8);
		Canvas.SetPos(Canvas.SizeX, 0);
		Canvas.DrawTile(Texture'KillingFloorWeapons.L85.L85Cross', -(Canvas.SizeX - Canvas.SizeY) / 2, Canvas.SizeY, 0.0, 0.0, 8, 8);

		//The view through the scope itself.
		Canvas.Style = 255;
		Canvas.SetPos((Canvas.SizeX - Canvas.SizeY) / 2,0);
		Canvas.DrawTile(ZoomMat, Canvas.SizeY, Canvas.SizeY, 0.0, 0.0, 512, 512);

		//Draw some useful text.
		Canvas.Font = Canvas.MedFont;
		Canvas.SetDrawColor(200,150,0);

		Canvas.SetPos(Canvas.SizeX * 0.16, Canvas.SizeY * 0.43);
		Canvas.DrawText("Zoom: 2.50");

		Canvas.SetPos(Canvas.SizeX * 0.16, Canvas.SizeY * 0.47);

        // Item Pickup Overlay


        // A cheap but effective way of determining and displaying how much ammo in clip.
        if(ClipCount == 40)
        Canvas.DrawText("Ammo in clip: 40");
        else if(ClipCount == 39)
        Canvas.DrawText("Ammo in clip: 39");
        else if(ClipCount == 38)
        Canvas.DrawText("Ammo in clip: 38");
        else if(ClipCount == 37)
        Canvas.DrawText("Ammo in clip: 37");
        else if(ClipCount == 36)
        Canvas.DrawText("Ammo in clip: 36");
        else if(ClipCount == 35)
        Canvas.DrawText("Ammo in clip: 35");
        else if(ClipCount == 34)
        Canvas.DrawText("Ammo in clip: 34");
        else if(ClipCount == 33)
        Canvas.DrawText("Ammo in clip: 33");
        else if(ClipCount == 32)
        Canvas.DrawText("Ammo in clip: 32");
        else if(ClipCount == 31)
        Canvas.DrawText("Ammo in clip: 31");
        else if(ClipCount == 30)
        Canvas.DrawText("Ammo in clip: 30");
        else if(ClipCount == 29)
        Canvas.DrawText("Ammo in clip: 29");
        else if(ClipCount == 28)
        Canvas.DrawText("Ammo in clip: 28");
        else if(ClipCount == 27)
        Canvas.DrawText("Ammo in clip: 27");
        else if(ClipCount == 26)
        Canvas.DrawText("Ammo in clip: 26");
        else if(ClipCount == 25)
        Canvas.DrawText("Ammo in clip: 25");
        else if(ClipCount == 24)
        Canvas.DrawText("Ammo in clip: 24");
        else if(ClipCount == 23)
        Canvas.DrawText("Ammo in clip: 23");
        else if(ClipCount == 22)
        Canvas.DrawText("Ammo in clip: 22");
        else if(ClipCount == 21)
        Canvas.DrawText("Ammo in clip: 21");
        else if(ClipCount == 20)
        Canvas.DrawText("Ammo in clip: 20");
        else if(ClipCount == 19)
        Canvas.DrawText("Ammo in clip: 19");
        else if(ClipCount == 18)
        Canvas.DrawText("Ammo in clip: 18");
        else if(ClipCount == 17)
        Canvas.DrawText("Ammo in clip: 17");
        else if(ClipCount == 16)
        Canvas.DrawText("Ammo in clip: 16");
        else if(ClipCount == 15)
        Canvas.DrawText("Ammo in clip: 15");
        else if(ClipCount == 14)
        Canvas.DrawText("Ammo in clip: 14");
        else if(ClipCount == 13)
        Canvas.DrawText("Ammo in clip: 13");
        else if(ClipCount == 12)
        Canvas.DrawText("Ammo in clip: 12");
        else if(ClipCount == 11)
        Canvas.DrawText("Ammo in clip: 11");
        else if(ClipCount == 10)
        Canvas.DrawText("Ammo in clip: 10");
        else if(ClipCount == 9)
        Canvas.DrawText("Ammo in clip: 9");
        else if(ClipCount == 8)
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount == 7)
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount == 6)       // Not ClipCount < 6 because that would overwrite the reload text.
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount == 5)
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount == 4)
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount == 3)
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount == 2)
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount == 1)
        Canvas.DrawText("Low Ammo!");
        else if(ClipCount < 1)
        Canvas.DrawText("Empty");

       	Canvas.SetPos(Canvas.SizeX * 0.16, Canvas.SizeY * 0.51);
		Canvas.DrawText("Direction:"@normalize(Instigator.GetViewRotation()).Pitch / 182.0);

        Canvas.SetPos(Canvas.SizeX * 0.16, Canvas.SizeY * 0.55);
        if ( FireMode[0].bWaitForRelease == True )
        Canvas.DrawText("FireMode: Semi Auto");
        else
        Canvas.DrawText("FireMode: Full Auto");

        zoomed = true;
	}
}

function float GetAIRating()
{
	local Bot B;


	B = Bot(Instigator.Controller);
	if ( (B == None) || (B.Enemy == None) )
		return AIRating;

	return (AIRating + 0.0003 * FMin(VSize(B.Enemy.Location - Instigator.Location),1000));
}

function byte BestMode()
{
    return 0;
}

simulated function ClientStartFire(int mode)
{
    if (mode == 1)
    {
        FireMode[mode].bIsFiring = true;
        ZoomLevel = 0.590;
        PlayerController(Instigator.Controller).DesiredFOV = FClamp(90.0 - (ZoomLevel * 88.0), 1, 170);
    }
    else
    {
        Super.ClientStartFire(mode);
    }
}

simulated function ClientStopFire(int mode)
{
    if (mode == 1)
    {
        FireMode[mode].bIsFiring = false;
        if( PlayerController(Instigator.Controller) != None )
        ZoomLevel = 0.0;
        PlayerController(Instigator.Controller).ToggleZoom();
    }
    else
    {
        Super.ClientStopFire(mode);
    }
}

simulated function BringUp(optional Weapon PrevWeapon)
{
    if ( PlayerController(Instigator.Controller) != None )
    {
        LastFOV = PlayerController(Instigator.Controller).DesiredFOV;
	}
    Super.BringUp(PrevWeapon);
}

simulated function bool PutDown()
{
    if( Instigator.Controller.IsA( 'PlayerController' ) )
        PlayerController(Instigator.Controller).EndZoom();
    if ( Super.PutDown() )
    {
		GotoState('');
		return true;
	}
	return false;
}

simulated function SetZoomBlendColor(Canvas c)
{
    local Byte    val;
    local Color   clr;
    local Color   fog;

    clr.R = 255;
    clr.G = 255;
    clr.B = 255;
    clr.A = 255;

    if( Instigator.Region.Zone.bDistanceFog )
    {
        fog = Instigator.Region.Zone.DistanceFogColor;
        val = 0;
        val = Max( val, fog.R);
        val = Max( val, fog.G);
        val = Max( val, fog.B);

        if( val > 128 )
        {
            val -= 128;
            clr.R -= val;
            clr.G -= val;
            clr.B -= val;
        }
    }
    c.DrawColor = clr;
}

defaultproperties
{
     ZoomMat=Texture'KillingFloorWeapons.L85.L85Cross'
     ClipCount=40
     ReloadRate=1.4
     ReloadBeginSound=Sound'KFWeaponSound.L85Clipchange'
     ReloadSound=Sound'KFWeaponSound.L85Cock'
     ReloadAnim="Reload"
     ReloadAnimRate = 0.9
     FireModeClass(0)=Class'KFmod.L85Fire'
     FireModeClass(1)=Class'KFMod.KFZoom'
     PutDownAnim="PutDown"
     SelectForce="SwitchToAssaultRifle"
     SelectSound=Sound'KFPlayerSound.getweaponout'
     AIRating=0.600000
     CurrentRating=0.600000
     bShowChargingBar=True
     OldCenteredOffsetY=0.000000
     OldPlayerViewOffset=(X=-8.000000,Y=5.000000,Z=-6.000000)
     OldSmallViewOffset=(X=4.000000,Y=11.000000,Z=-12.000000)
     OldPlayerViewPivot=(Pitch=400)
     OldCenteredRoll=3000
     Description="Automatic Rifle with good accuracy."
     EffectOffset=(X=100.000000,Y=25.000000,Z=-10.000000)
     DisplayFOV=70.000000
     Priority=26
     SmallViewOffset=(X=13.000000,Y=12.000000,Z=-10.000000)
     CenteredOffsetY=-5.000000
     CenteredRoll=3000
     CenteredYaw=-1500
     InventoryGroup=3
     PickupClass=Class'KFmod.L85Pickup'
     PlayerViewOffset=(X=4.000000,Y=5.500000,Z=-6.000000)
     PlayerViewPivot=(Pitch=400)
     BobDamping=6.000000
     AttachmentClass=Class'KFmod.L85Attachment'
     IconMaterial=Texture'KillingFloorHUD.Generic.HUD'
     IconCoords=(X1=245,Y1=39,X2=329,Y2=79)
     ItemName="Bullpup"
     Mesh=SkeletalMesh'KFWeaponModels.L85'
     TransientSoundVolume=1.250000
     TransientSoundRadius=300.000000
     DrawScale=0.900000
}
