//=============================================================================
// Nade
//=============================================================================
class Nade extends Grenade;

simulated function Explode(vector HitLocation, vector HitNormal)
{
    BlowUp(HitLocation);
    PlaySound(sound'WeaponSounds.BExplosion3',,100.5*TransientSoundVolume);
    if ( EffectIsRelevant(Location,false) )
    {
        Spawn(class'KFMod.KFNadeExplosion',,, HitLocation, rotator(vect(0,0,1)));
        Spawn(ExplosionDecal,self,,HitLocation, rotator(-HitNormal));
    }
    Destroy();
}

simulated function Destroyed()
{
    if ( Trail == None )
        Trail.mRegen = false; // stop the emitter from regenerating
    Super.Destroyed();
}


simulated function PostBeginPlay()
{
    local PlayerController PC;
    
    Super.PostBeginPlay();

    if ( Level.NetMode != NM_DedicatedServer)
    {
        PC = Level.GetLocalPlayerController();
        if ( (PC.ViewTarget != None) && VSize(PC.ViewTarget.Location - Location) < 5500 )
      }

    if ( Role == ROLE_Authority )
    {
        Velocity = Speed * Vector(Rotation);
        RandSpin(25000);
        bCanHitOwner = false;
        if (Instigator.HeadVolume.bWaterVolume)
        {
            bHitWater = true;
            Velocity = 0.6*Velocity;
        }
    }
}

simulated function ProcessTouch( actor Other, vector HitLocation )
{
   // if ( !Other.bWorldGeometry && (Other != Instigator || bCanHitOwner) )
    //{
      //  Explode(HitLocation, Normal(HitLocation-Other.Location));
   // }
}

defaultproperties
{
     DampenFactor=0.25
     DampenFactorParallel=0.4
     ExplodeTimer=2.000000
     Speed=160.000000
     MaxSpeed=350.000000
     Damage=200.000000
     DamageRadius=550.000000
     MomentumTransfer=200000.000000
     StaticMesh=StaticMesh'KillingFloorStatics.FragProjectile'
     DrawScale=.400000
     AmbientGlow=0
     HitEffectClass=none
     MyDamageType=class'KFMod.DamTypeFrag'

}
